<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Unregister ServiceType
 * @subpackage Services
 */
class Unregister extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named unregisterPermanentListenerFor
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\UnregisterPermanentListenerFor $parameters
     * @return \StructType\UnregisterPermanentListenerForResponse|bool
     */
    public function unregisterPermanentListenerFor(\StructType\UnregisterPermanentListenerFor $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->unregisterPermanentListenerFor($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\UnregisterPermanentListenerForResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
