<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PushUser StructType
 * @subpackage Structs
 */
class PushUser extends AbstractStructBase
{
    /**
     * The contextId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $contextId;
    /**
     * The userId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $userId;
    /**
     * Constructor method for PushUser
     * @uses PushUser::setContextId()
     * @uses PushUser::setUserId()
     * @param int $contextId
     * @param int $userId
     */
    public function __construct($contextId = null, $userId = null)
    {
        $this
            ->setContextId($contextId)
            ->setUserId($userId);
    }
    /**
     * Get contextId value
     * @return int|null
     */
    public function getContextId()
    {
        return $this->contextId;
    }
    /**
     * Set contextId value
     * @param int $contextId
     * @return \StructType\PushUser
     */
    public function setContextId($contextId = null)
    {
        // validation for constraint: int
        if (!is_null($contextId) && !is_numeric($contextId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($contextId)), __LINE__);
        }
        $this->contextId = $contextId;
        return $this;
    }
    /**
     * Get userId value
     * @return int|null
     */
    public function getUserId()
    {
        return $this->userId;
    }
    /**
     * Set userId value
     * @param int $userId
     * @return \StructType\PushUser
     */
    public function setUserId($userId = null)
    {
        // validation for constraint: int
        if (!is_null($userId) && !is_numeric($userId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($userId)), __LINE__);
        }
        $this->userId = $userId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PushUser
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
