<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PushUserClient StructType
 * @subpackage Structs
 */
class PushUserClient extends AbstractStructBase
{
    /**
     * The client
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $client;
    /**
     * The pushUser
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PushUser
     */
    public $pushUser;
    /**
     * Constructor method for PushUserClient
     * @uses PushUserClient::setClient()
     * @uses PushUserClient::setPushUser()
     * @param string $client
     * @param \StructType\PushUser $pushUser
     */
    public function __construct($client = null, \StructType\PushUser $pushUser = null)
    {
        $this
            ->setClient($client)
            ->setPushUser($pushUser);
    }
    /**
     * Get client value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getClient()
    {
        return isset($this->client) ? $this->client : null;
    }
    /**
     * Set client value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $client
     * @return \StructType\PushUserClient
     */
    public function setClient($client = null)
    {
        // validation for constraint: string
        if (!is_null($client) && !is_string($client)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($client)), __LINE__);
        }
        if (is_null($client) || (is_array($client) && empty($client))) {
            unset($this->client);
        } else {
            $this->client = $client;
        }
        return $this;
    }
    /**
     * Get pushUser value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PushUser|null
     */
    public function getPushUser()
    {
        return isset($this->pushUser) ? $this->pushUser : null;
    }
    /**
     * Set pushUser value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PushUser $pushUser
     * @return \StructType\PushUserClient
     */
    public function setPushUser(\StructType\PushUser $pushUser = null)
    {
        if (is_null($pushUser) || (is_array($pushUser) && empty($pushUser))) {
            unset($this->pushUser);
        } else {
            $this->pushUser = $pushUser;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PushUserClient
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
