<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PushUserInfo StructType
 * @subpackage Structs
 */
class PushUserInfo extends AbstractStructBase
{
    /**
     * The permanent
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $permanent;
    /**
     * The pushUser
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PushUser
     */
    public $pushUser;
    /**
     * Constructor method for PushUserInfo
     * @uses PushUserInfo::setPermanent()
     * @uses PushUserInfo::setPushUser()
     * @param bool $permanent
     * @param \StructType\PushUser $pushUser
     */
    public function __construct($permanent = null, \StructType\PushUser $pushUser = null)
    {
        $this
            ->setPermanent($permanent)
            ->setPushUser($pushUser);
    }
    /**
     * Get permanent value
     * @return bool|null
     */
    public function getPermanent()
    {
        return $this->permanent;
    }
    /**
     * Set permanent value
     * @param bool $permanent
     * @return \StructType\PushUserInfo
     */
    public function setPermanent($permanent = null)
    {
        // validation for constraint: boolean
        if (!is_null($permanent) && !is_bool($permanent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($permanent)), __LINE__);
        }
        $this->permanent = $permanent;
        return $this;
    }
    /**
     * Get pushUser value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PushUser|null
     */
    public function getPushUser()
    {
        return isset($this->pushUser) ? $this->pushUser : null;
    }
    /**
     * Set pushUser value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PushUser $pushUser
     * @return \StructType\PushUserInfo
     */
    public function setPushUser(\StructType\PushUser $pushUser = null)
    {
        if (is_null($pushUser) || (is_array($pushUser) && empty($pushUser))) {
            unset($this->pushUser);
        } else {
            $this->pushUser = $pushUser;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PushUserInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
