<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for unregisterPermanentListenerFor StructType
 * @subpackage Structs
 */
class UnregisterPermanentListenerFor extends AbstractStructBase
{
    /**
     * The userId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $userId;
    /**
     * The contextId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $contextId;
    /**
     * The client
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $client;
    /**
     * The admin
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $admin;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $password;
    /**
     * Constructor method for unregisterPermanentListenerFor
     * @uses UnregisterPermanentListenerFor::setUserId()
     * @uses UnregisterPermanentListenerFor::setContextId()
     * @uses UnregisterPermanentListenerFor::setClient()
     * @uses UnregisterPermanentListenerFor::setAdmin()
     * @uses UnregisterPermanentListenerFor::setPassword()
     * @param int $userId
     * @param int $contextId
     * @param string $client
     * @param string $admin
     * @param string $password
     */
    public function __construct($userId = null, $contextId = null, $client = null, $admin = null, $password = null)
    {
        $this
            ->setUserId($userId)
            ->setContextId($contextId)
            ->setClient($client)
            ->setAdmin($admin)
            ->setPassword($password);
    }
    /**
     * Get userId value
     * @return int|null
     */
    public function getUserId()
    {
        return $this->userId;
    }
    /**
     * Set userId value
     * @param int $userId
     * @return \StructType\UnregisterPermanentListenerFor
     */
    public function setUserId($userId = null)
    {
        // validation for constraint: int
        if (!is_null($userId) && !is_numeric($userId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($userId)), __LINE__);
        }
        $this->userId = $userId;
        return $this;
    }
    /**
     * Get contextId value
     * @return int|null
     */
    public function getContextId()
    {
        return $this->contextId;
    }
    /**
     * Set contextId value
     * @param int $contextId
     * @return \StructType\UnregisterPermanentListenerFor
     */
    public function setContextId($contextId = null)
    {
        // validation for constraint: int
        if (!is_null($contextId) && !is_numeric($contextId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($contextId)), __LINE__);
        }
        $this->contextId = $contextId;
        return $this;
    }
    /**
     * Get client value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getClient()
    {
        return isset($this->client) ? $this->client : null;
    }
    /**
     * Set client value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $client
     * @return \StructType\UnregisterPermanentListenerFor
     */
    public function setClient($client = null)
    {
        // validation for constraint: string
        if (!is_null($client) && !is_string($client)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($client)), __LINE__);
        }
        if (is_null($client) || (is_array($client) && empty($client))) {
            unset($this->client);
        } else {
            $this->client = $client;
        }
        return $this;
    }
    /**
     * Get admin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAdmin()
    {
        return isset($this->admin) ? $this->admin : null;
    }
    /**
     * Set admin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $admin
     * @return \StructType\UnregisterPermanentListenerFor
     */
    public function setAdmin($admin = null)
    {
        // validation for constraint: string
        if (!is_null($admin) && !is_string($admin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($admin)), __LINE__);
        }
        if (is_null($admin) || (is_array($admin) && empty($admin))) {
            unset($this->admin);
        } else {
            $this->admin = $admin;
        }
        return $this;
    }
    /**
     * Get password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPassword()
    {
        return isset($this->password) ? $this->password : null;
    }
    /**
     * Set password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $password
     * @return \StructType\UnregisterPermanentListenerFor
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        if (is_null($password) || (is_array($password) && empty($password))) {
            unset($this->password);
        } else {
            $this->password = $password;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UnregisterPermanentListenerFor
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
